package linkMRM.ExFrameSample;

import java.awt.Dimension;
import java.awt.Point;

import view.modeling.ViewableComponent;
import view.modeling.ViewableDigraph;

public class EF extends ViewableDigraph {

	String folderName;
	
	public EF(String folderName) {
		super("EF");
		this.folderName = folderName;
		buildModel();
		initialize();
		
		addOutport("channelIn");
		addOutport("failStopSignal");
		addOutport("upChannelReconfig");
		addOutport("send");
		addInport("channelOut");
	}
	
	private void buildModel() {
				
		Transducer trans = new Transducer(this.folderName);
		Generator gen = new Generator(this.folderName);
		
		add(gen);
		add(trans);
		
		addCoupling(this, "channelOut", trans, "channelOut");
		addCoupling(gen, "channelIn", this, "channelIn");
		addCoupling(gen, "failStopSignal", this, "failStopSignal");
		addCoupling(gen, "upChannelReconfig", this, "upChannelReconfig");
		addCoupling(gen, "send", this, "send");

	}	
    /**
     * Automatically generated by the SimView program.
     * Do not edit this manually, as such changes will get overwritten.
     */
    public void layoutForSimView()
    {
        preferredSize = new Dimension(467, 157);
        ((ViewableComponent)withName("transducer")).setPreferredLocation(new Point(43, 95));
        ((ViewableComponent)withName("generator")).setPreferredLocation(new Point(40, 20));
    }
}
