package linkMRM.ExFrameSample;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.Base64;
import java.util.Scanner;
import GenCol.entity;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class Generator extends ViewableAtomic{

	String folderName;
	ArrayList<outputData> data = new ArrayList<outputData>();
	private outputData currentData;
	
	public Generator(String folderName) {
		super("generator");
		this.folderName = folderName;	

		addOutport("channelIn");
		addOutport("failStopSignal");
		addOutport("upChannelReconfig");
		addOutport("send");
		
		sigma = readFile();
	}

	/*initialization*/
	public void initialize( ){
		phase = "active";
		super.initialize();
	}

	/*Internal Transition Function*/
	public void  deltint( ){
		if(phaseIs("active")){
			if(this.data.size() > 0){
				this.currentData = this.data.remove(0);
				sigma = this.currentData.time;
			}
			else passivate();
		}
	}

	/*Output Function*/
	public message out(){
		message m = new message();
		if ((phaseIs("active")))
			m.add(makeContent(this.currentData.portName, this.currentData.output)); 
		return m;
	}
	
	protected double readFile() {
		File fileInputs = new File(folderName + "/inputs.txt");
		Scanner reader = null;
		try {
			reader = new Scanner(fileInputs);
		} catch (FileNotFoundException e) {
			System.out.println("Failure: Cannot read inputs file");
			e.printStackTrace();
			return INFINITY;
		}		

		
		double previousTime = 0;
		while(reader.hasNextLine()){
			Double time = Double.parseDouble(reader.nextLine());
			
			String portName = null;
			if(reader.hasNextLine())
				portName = reader.nextLine();
			else continue;
			
			entity output = null;
						
			try {
				output = (entity)deserializeObject(reader.nextLine());
			} catch (ClassNotFoundException | IOException e) {
				System.out.println("Failure - deserialization incomplete");
				e.printStackTrace();
				continue;
			}
					
			this.data.add(new outputData(portName, time - previousTime, output));
			previousTime = time;
		}

		this.currentData = this.data.remove(0);
		return this.currentData.time;
	}

	protected Object deserializeObject(String objectString) throws IOException ,
	ClassNotFoundException {
		byte [] data = Base64.getDecoder().decode(objectString);
		ObjectInputStream ois = new ObjectInputStream( 
				new ByteArrayInputStream(data));
		Object o  = ois.readObject();
		ois.close();
		return o;
	}

	protected class outputData {
		String portName;
		double time;
		entity output;
		
		public outputData(String portname, double time, entity output){
			this.portName = portname;
			this.time = time;
			this.output = output;
		}
	}
	
}
