package linkMRM.L1;

import java.awt.Color;
import java.util.Random;

import model.modeling.content;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class Generator extends ViewableAtomic{

	int experimentsSoFar;
	int allExperiments;
	boolean windowOpen;
	Random rand = new Random();
	
	public Generator(){
		this("Generator");
	}
	
	public Generator(String name){
		super(name);
		
		addInport("ackFromLink");
		addOutport("toLink");
		
		this.backgroundColor = Color.CYAN;
	}
	
	/*initialization*/
	public void initialize( ){
		phase = "active";
		sigma = 1;
		experimentsSoFar = 0;
		allExperiments = 4;
		windowOpen = true;
		super.initialize();
	}
	
	/*External Transition Function*/
	public void  deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "ackFromLink", i)){
				windowOpen = true;
			}
		}
	}
	
	public void deltint(){
		if(experimentsSoFar == 0 && windowOpen){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 1);
		}
		
		else if(experimentsSoFar == 1 && windowOpen){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 3);
		}
		
		else if(experimentsSoFar == 2 && windowOpen){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", .5);
		}
		
		else if(experimentsSoFar == 3){
			experimentsSoFar++;
			windowOpen = false;
		}
		
		if(experimentsSoFar >= allExperiments)
			passivate();
	}
	
	public message out(){
		message m = new message();
		if(experimentsSoFar == 0 && windowOpen){
			flit newFlit = flit.newHeadFlit(0, 0, createRandomeData(2));
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 1 && windowOpen){
			flit newFlit = flit.newHeadFlit(1, 1, createRandomeData(2));
			newFlit.setDelayAtLink(2);
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 2 && windowOpen){
			flit newFlit = flit.newHeadFlit(2, 2, createRandomeData(2));
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 3){
			flit newFlit = flit.newHeadFlit(3, 3, createRandomeData(2));
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		return m;
	}
	
	public byte[] createRandomeData(int numberOfBytes){
		byte[] data = new byte[numberOfBytes];
		rand.nextBytes(data);
		return data;
	}
}
