package linkMRM.L1;

import java.awt.Color;

import GenCol.entity;
import model.modeling.message;
import view.modeling.ViewableAtomic;

/*
 * This is the high level model of the link. 
 */

public class Link1 extends ViewableAtomic{
	protected double linkDelay;
	protected flit travellingFlit;
	
	public Link1() {this("Link", 1);}
	public Link1(String name, double delay){
		super(name);

		addInport("linkIn");
		addOutport("linkOut");
		addOutport("ack");

		this.linkDelay = delay;
		
		this.backgroundColor = Color.PINK;

	}

	/*initialization*/
	public void initialize( ){
		phase = "passive";
		sigma = INFINITY;
		super.initialize( );
	}

	/*External Transition Function*/
	public void  deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "linkIn", i)){
				travellingFlit = (flit) (x.getValOnPort("linkIn", i));
				holdIn("active", travellingFlit.getDelayAtLink());
			}
		}
	}

	/*Internal Transition Function*/
	public void  deltint( ){
		if(phaseIs("active")){
			passivate();
		}
	}

	/*Output Function*/
	public message out(){
		message m = new message();
		if ((phaseIs("active"))){	  
			m.add(makeContent("linkOut", travellingFlit));
			m.add(makeContent("ack", new entity("ACK")));
		}  
		return m;
	}

}
