package linkMRM.L1;

import GenCol.*;

enum FlitType {Head, Tail, Norm} 
public class flit extends entity{
	public int srcID, dstID, seqNo;
	public FlitType type;
	byte[] data;
	
	double delayAtLink = 1;

	public flit(FlitType type, int seqNo, int srcID, int dstID, byte[] data){
		super(type+":"+srcID+"-"+seqNo+"->"+dstID);
		this.dstID = dstID;
		this.srcID = srcID;
		this.type = type;
		this.seqNo = seqNo;
		this.data = data;
	}
	
	public static flit newHeadFlit(int source, int destination, byte[] data){
		return new flit(FlitType.Head, 0, source, destination, data);
	}

	public flit(){
		super();
	}
	
	public byte[] getData(){
		return this.data;
	}
	
	public void print(){
		System.out.println("flit: " + name);
	}
	
	public boolean equals(Object o){
		if(!(o instanceof flit))
			return false;
		
		flit otherFlit = (flit)o;
		
		if(this.data.length != otherFlit.data.length)
			return false; 
		
		for(int i = 0 ; i < this.data.length ; i++)
			if(this.data[i] != otherFlit.data[i])
				return false; 
		
		return true;
	}
	
	public void setDelayAtLink(double delay){
		this.delayAtLink = delay;
	}
	
	public double getDelayAtLink(){
		return this.delayAtLink;
	}

}