package linkMRM.L2;

import java.awt.Color;

import model.modeling.message;
import view.modeling.ViewableAtomic;

public class FailStopModule extends ViewableAtomic{

	protected double delay;
	protected int errorCount = 0;
	protected int allowedNumberOfErrors;
	
	public FailStopModule() {this("Fail Stop Module", .1, 5);}
	public FailStopModule(String name, double delay, int allowedNumberOfErrors){
		super(name);

		addInport("confirmation");
		addOutport("stop");

		this.delay = delay;
		this.allowedNumberOfErrors = allowedNumberOfErrors;
		
		this.backgroundColor = Color.MAGENTA;

	}
	
	public void deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "confirmation", i)){
				if((x.getValOnPort("confirmation", i)).eq("nack")){
					errorCount++;
					if(errorCount >= this.allowedNumberOfErrors)
						holdIn("failStop", delay);
				}
			}
		}
	}

	public void deltint(){
		passivate();
	}
	
	public message out(){
		message msg = new message();
		if(phaseIs("failStop")){
			msg.add(makeContent("stop", new Signal(1)));
		}
		return msg;
	}
}
