package linkMRM.L2;

import java.awt.Color;
import java.util.Random;

import linkMRM.flitSuper;
import model.modeling.content;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class Generator extends ViewableAtomic{

	int experimentsSoFar;
	int allExperiments;
	boolean windowOpen;
	Random rand = new Random();
	
	public Generator(){
		this("Generator");
	}
	
	public Generator(String name){
		super(name);
		
		addInport("ackFromLink");
		addOutport("toLink");
		
		this.backgroundColor = Color.CYAN;

	}
	
	/*initialization*/
	public void initialize( ){
		phase = "active";
		sigma = 1;
		experimentsSoFar = 0;
		allExperiments = 7;
		windowOpen = true;
		super.initialize();
	}
	
	/*External Transition Function*/
	public void  deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "ackFromLink", i)){
				windowOpen = true;
			}
		}
	}
	
	public void deltint(){
		if(experimentsSoFar == 0 && windowOpen){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 1);
		}
		
		else if(experimentsSoFar == 1 && windowOpen){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 3);
		}
		
		else if(experimentsSoFar == 2 && windowOpen){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 6);
		}
		
		else if(experimentsSoFar == 3 && windowOpen){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 6);
		}
		
		else if(experimentsSoFar == 4 && windowOpen){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 4);
		}
		
		else if(experimentsSoFar == 5){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 4);
		}
		
		else if(experimentsSoFar == 6){
			experimentsSoFar++;
			windowOpen = false;
			holdIn("active", 4);
		}
		
		if(experimentsSoFar >= allExperiments)
			passivate();
	}
	
	public message out(){
		message m = new message();
		if(experimentsSoFar == 0 && windowOpen){
			flitSuper newFlit = new flitSuper(new int[Config.databits], new int[Config.controlbits], 
					flitSuper.FlitType.L2);
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 1 && windowOpen){
			flitSuper newFlit = new flitSuper(new int[Config.databits], new int[Config.controlbits], 
					flitSuper.FlitType.L2);
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 2 && windowOpen){
			flitSuper newFlit = new flitSuper(new int[Config.databits], new int[Config.controlbits], 
					flitSuper.FlitType.L2);
			newFlit.setWrongTransmissionCount(1);
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 3){
			flitSuper newFlit = new flitSuper(new int[Config.databits], new int[Config.controlbits], 
					flitSuper.FlitType.L2);
			newFlit.setWrongTransmissionCount(3);
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 4){
			flitSuper newFlit = new flitSuper(new int[Config.databits], new int[Config.controlbits], 
					flitSuper.FlitType.L2);
			newFlit.setWrongTransmissionCount(2);
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 5){
			flitSuper newFlit = new flitSuper(new int[Config.databits], new int[Config.controlbits], 
					flitSuper.FlitType.L2);
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		
		if(experimentsSoFar == 6){
			flitSuper newFlit = new flitSuper(new int[Config.databits], new int[Config.controlbits], 
					flitSuper.FlitType.L2);
			newFlit.setWrongTransmissionCount(1);
			content c = makeContent("toLink", newFlit);
			m.add(c);
		}
		return m;
	}
	
	public byte[] createRandomeData(int numberOfBytes){
		byte[] data = new byte[numberOfBytes];
		rand.nextBytes(data);
		return data;
	}
}