package linkMRM.L2;

import java.awt.Dimension;
import java.awt.Point;

import view.modeling.ViewableComponent;
import view.modeling.ViewableDigraph;

public class Link2 extends ViewableDigraph{

	public Link2(){
		this("Mid-Level Link");
	}
	
	public Link2(String name) {
		super(name);
		
		addInport("linkIn");
		addOutport("linkOut");
		addOutport("ack");
		addOutport("failStop");
		
		buildModel();
		initialize();
	}

	private void buildModel() {
		Channel channel = new Channel();
		ErrorCheckingModule checksumModule = new ErrorCheckingModule();
		OutputModule outModule = new OutputModule();
		RetransmissionModule retransModule = new RetransmissionModule();
		FailStopModule failStopModule = new FailStopModule();
		
		add(channel);
		add(checksumModule);
		add(outModule);
		add(retransModule);
		add(failStopModule);
		
		addCoupling(this, "linkIn", channel, "channelIn");
		addCoupling(outModule, "linkOut", this, "linkOut");
		addCoupling(retransModule, "ack", this, "ack");
		addCoupling(failStopModule, "stop", this, "failStop");

		addCoupling(channel, "channelOut", checksumModule, "channelOutput");
		addCoupling(channel, "channelOut", outModule, "channelOutput");
		
		addCoupling(checksumModule, "confirmation", outModule, "confirmation");
		addCoupling(checksumModule, "confirmation", retransModule, "confirmation");
		addCoupling(checksumModule, "confirmation", failStopModule, "confirmation");

		addCoupling(retransModule, "send", channel, "send");
		addCoupling(failStopModule, "stop", channel, "failStopSignal");

	}

    /**
     * Automatically generated by the SimView program.
     * Do not edit this manually, as such changes will get overwritten.
     */
    public void layoutForSimView()
    {
        preferredSize = new Dimension(739, 400);
        ((ViewableComponent)withName("Retransmission Module")).setPreferredLocation(new Point(-6, 38));
        ((ViewableComponent)withName("Channel")).setPreferredLocation(new Point(-4, 225));
        ((ViewableComponent)withName("Fail Stop Module")).setPreferredLocation(new Point(314, 324));
        ((ViewableComponent)withName("Error Checking Module")).setPreferredLocation(new Point(121, 139));
        ((ViewableComponent)withName("Output Module")).setPreferredLocation(new Point(363, 200));
    }
}
