package linkMRM.L3;

import java.awt.Dimension;
import java.awt.Point;
import java.util.ArrayList;

import view.modeling.ViewableComponent;
import view.modeling.ViewableDigraph;

public class Channel extends ViewableDigraph{

	public Channel() {
		this("L3 level Channel");
	}

	public Channel(String name) {
		super(name);

		//this.blackBox = true;
		
		addInport("channelIn");
		addInport("failStopSignal");
		addInport("upChannelReconfig");
		addInport("send");
		addOutport("channelOut");

		buildModel();
		initialize();
	}

	private void buildModel() {
		ChannelIn channelIn = new ChannelIn();
		ChannelOut channelOut = new ChannelOut();

		ArrayList<Wire> wires = new ArrayList<Wire>();

		for(int i = 0 ; i < Config.databits + Config.extraWires ; i++)
			wires.add(new Wire("dataWire" + i));
		for(int i = 0 ; i < Config.controlbits ; i++)
			wires.add(new Wire("controlWire" + i));

		add(channelIn);
		add(channelOut);
		for(int i = 0 ; i < wires.size() ; i++)
			add(wires.get(i));

		addCoupling(this, "channelIn", channelIn, "channelIn");
		addCoupling(this, "send", channelIn, "send");
		addCoupling(this, "failStopSignal", channelIn, "failStopSignal");
		
		addCoupling(this, "upChannelReconfig", channelIn, "reconfig");

		for(int i = 0 ; i < Config.databits + Config.extraWires ; i++){
			addCoupling(channelIn, "DataOut" + i, wires.get(i), "wireIn");
			addCoupling(wires.get(i), "wireOut", channelOut, "DataIn" + i);
		}

		int count = Config.databits + Config.extraWires; 
		for(int i = 0 ; i < Config.controlbits ; i++){
			addCoupling(channelIn, "ControlOut" + i, wires.get(count + i), "wireIn");
			addCoupling(wires.get(count + i), "wireOut", channelOut, "ControlIn" + i);
		}

		addCoupling(channelOut, "channelOut", this, "channelOut");
	}

    /**
     * Automatically generated by the SimView program.
     * Do not edit this manually, as such changes will get overwritten.
     */
    public void layoutForSimView()
    {
        preferredSize = new Dimension(949, 629);
        ((ViewableComponent)withName("ChannelOut")).setPreferredLocation(new Point(492, 201));
        ((ViewableComponent)withName("dataWire2")).setPreferredLocation(new Point(273, 243));
        ((ViewableComponent)withName("dataWire4")).setPreferredLocation(new Point(273, 351));
        ((ViewableComponent)withName("dataWire8")).setPreferredLocation(new Point(273, 567));
        ((ViewableComponent)withName("dataWire1")).setPreferredLocation(new Point(273, 189));
        ((ViewableComponent)withName("dataWire3")).setPreferredLocation(new Point(273, 297));
        ((ViewableComponent)withName("dataWire0")).setPreferredLocation(new Point(273, 135));
        ((ViewableComponent)withName("dataWire7")).setPreferredLocation(new Point(273, 513));
        ((ViewableComponent)withName("controlWire1")).setPreferredLocation(new Point(273, 81));
        ((ViewableComponent)withName("ChannelIn")).setPreferredLocation(new Point(-10, 204));
        ((ViewableComponent)withName("dataWire6")).setPreferredLocation(new Point(273, 459));
        ((ViewableComponent)withName("dataWire5")).setPreferredLocation(new Point(273, 405));
        ((ViewableComponent)withName("controlWire0")).setPreferredLocation(new Point(273, 27));
    }
}
