package linkMRM.L3;

import java.awt.Color;

import GenCol.entity;
import linkMRM.flitSuper;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class ChannelIn extends ViewableAtomic{
	protected double channelInDelay;
	protected flitSuper travellingFlit;
	
	boolean[] badPort;

	public ChannelIn() {this("ChannelIn", Config.channelInDelay);}
	public ChannelIn(String name, double delay){
		super(name);

		addInport("channelIn");
		addInport("send");
		addInport("failStopSignal");
		addInport("reconfig");
		
		badPort = new boolean[Config.databits + Config.extraWires + Config.controlbits];
		
		for(int i = 0 ; i < Config.databits + Config.extraWires ; i++){
			addOutport("DataOut" + i);
			badPort[i] = false;
		}
		for(int i = 0 ; i < Config.controlbits ; i++){
			addOutport("ControlOut" + i);
			badPort[Config.databits + Config.extraWires + i] = false;
		}
		
		this.channelInDelay = delay;
		this.backgroundColor = Color.PINK;

	}

	/*initialization*/
	public void initialize( ){
		phase = "passive";
		sigma = INFINITY;
		super.initialize( );
	}

	/*External Transition Function*/
	public void  deltext(double e, message x){
		Continue(e);
		if(!phaseIs("stop")){
			for(int i = 0 ; i < x.size() ; i++){
				if(messageOnPort(x, "channelIn", i)){
					travellingFlit = (flitSuper) (x.getValOnPort("channelIn", i));
					holdIn("active", channelInDelay);
				}

				else if(messageOnPort(x, "send", i)){
					travellingFlit.getErroneousWire();
					holdIn("active", channelInDelay);
				}

				else if(messageOnPort(x, "failStopSignal", i)){
					holdIn("stop", INFINITY);
					break;
				}
				
				else if(messageOnPort(x, "reconfig", i)){
					int erroneousWire = Integer.parseInt(x.getValOnPort("reconfig", i).getName());
					badPort[erroneousWire] = true;
					System.out.println("Channel reconfiguration done for : " + erroneousWire);
				}
			}
		}
	}

	/*Internal Transition Function*/
	public void  deltint(){
		if(phaseIs("active")){
			passivate();
		}
	}

	/*Output Function*/
	public message out(){
		message m = new message();
		if ((phaseIs("active"))){	 
			int dataCount = 0;
			System.out.print("Sending out flit using data wires: ");
			for(int i = 0 ; i < Config.databits + Config.extraWires ; i++){
				if(this.badPort[i] == false){
					m.add(makeContent("DataOut"+i, 
						new entity(Integer.toString(travellingFlit.getData()[dataCount]))));
					System.out.print(i + " ");
					dataCount++;
				}
				if(dataCount == Config.databits)
					break;
			}
			System.out.print("\nSending out flit using control wires: ");
			for(int i = 0 ; i < Config.controlbits ; i++){
				m.add(makeContent("ControlOut"+i, 
						new entity(Integer.toString(travellingFlit.getControl()[i]))));
				System.out.print(i + " ");
			}
			System.out.println();
		}  
		return m;
	}
}
