package linkMRM.L3;

import java.awt.Color;
import java.util.Arrays;

import linkMRM.flitSuper;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class ChannelOut extends ViewableAtomic {
	protected double channelOutDelay;
	protected int[] outDataHolder;

	String[] allInputPorts;
	boolean[] portStatus;

	public ChannelOut() {this("ChannelOut", Config.channleOutDelay);}
	public ChannelOut(String name, double delay){
		super(name);

		outDataHolder = new int[Config.databits + Config.controlbits];
		allInputPorts = new String[Config.controlbits + Config.databits + Config.extraWires];
		portStatus = new boolean[Config.controlbits + Config.databits + Config.extraWires];

		buildInports();
		addInport("reconfig");
		addOutport("channelOut");

		this.channelOutDelay = delay;
		this.backgroundColor = Color.cyan;

	}

	private void buildInports(){
		for(int i = 0 ; i < Config.databits + Config.extraWires ; i++){
			addInport("DataIn" + i);
			allInputPorts[i] = "DataIn" + i;
		}
		for(int i = 0 ; i < Config.controlbits ; i++){
			addInport("ControlIn" + i);	
			allInputPorts[Config.databits + Config.extraWires + i] = "ControlIn" + i;
		}
	}

	/*initialization*/
	public void initialize( ){
		phase = "passive";
		sigma = INFINITY;
		super.initialize( );
	}

	/*External Transition Function*/
	public void  deltext(double e, message x){
		Continue(e);
		if(!phaseIs("stop")){
				receiveData(x);
				holdIn("active", this.channelOutDelay);
		}
	}

	/*Internal Transition Function*/
	public void  deltint( ){
		if(phaseIs("active")){
			passivate();
		}
	}


	/*Output Function*/
	public message out(){
		message m = new message();
		if ((phaseIs("active"))){	 
			int[] dataBits = new int[Config.databits];
			int[] controlBits = new int[Config.controlbits];

			for(int i = 0 ; i < Config.databits ; i++)
				dataBits[i] = outDataHolder[i];

			for(int i = 0 ; i < Config.controlbits ; i++)
				controlBits[i] = outDataHolder[Config.databits + i];

			System.out.println("Channel out: sending out flit: " + 
					Arrays.toString(dataBits) + " - " + Arrays.toString(controlBits));
			
			flitSuper thisFlit = new flitSuper(dataBits, controlBits, flitSuper.FlitType.L3);
			m.add(makeContent("channelOut", thisFlit));
		}  
		return m;
	}

	private void receiveData(message m){
		int dataCounter = 0;
		for(int i = 0 ; i < this.allInputPorts.length ; i++){
			for(int number = 0 ; number < m.size() ; number++){
				if(messageOnPort(m, allInputPorts[i], number)){
					int bit = Integer.parseInt(
							m.getValOnPort(allInputPorts[i], number).getName());
					this.outDataHolder[dataCounter] = bit;
					dataCounter++;		
					break;
				}	
			}
		}
	}
}
