package linkMRM.L3;

import java.awt.Color;
import java.util.HashMap;

import GenCol.entity;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class ChannelReconfigure extends ViewableAtomic{

	protected double reconfigurationDelay;
	protected int linkToDisable;
	protected HashMap<Integer, Integer> wireErrors = new HashMap<Integer, Integer>();

	public ChannelReconfigure() {this("Channel Reconfig Module", Config.reconfigDelay);}
	public ChannelReconfigure(String name) {this(name, Config.reconfigDelay);}
	public ChannelReconfigure(String name, double delay){
		super(name);

		addInport("bitError");
		addOutport("reconfig");

		this.reconfigurationDelay = delay;
		this.backgroundColor = Color.PINK;
	}

	/*initialization*/
	public void initialize( ){
		phase = "passive";
		sigma = INFINITY;
		super.initialize( );
	}

	/*External Transition Function*/
	public void  deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "bitError", i)){
				int wireError = 0;
				try{
					wireError = Integer.parseInt(x.getValOnPort("bitError", i).getName());
					if(wireErrors.containsKey(wireError)){
						int faults = wireErrors.get(wireError) + 1;
						if(faults >= Config.maxErrorsInWire){
							holdIn("active", this.reconfigurationDelay);
							linkToDisable = wireError;
						}
					}
					else{
						wireErrors.put(wireError, 1);
					}
				} catch(Exception exp){
					System.out.println("confirmation");
				}
			}
		}
	}

	/*Internal Transition Function*/
	public void  deltint(){
		if(phaseIs("active")){
			passivate();
		}
	}
	
	/*Output Function*/
	public message out(){
		message m = new message();
		if ((phaseIs("active"))){	 
			m.add(makeContent("reconfig", 
					new entity(Integer.toString(this.linkToDisable))));
			System.out.println("Channel reconfiguration decision made for : " + this.linkToDisable);
		}  
		return m;
	}
}
