package linkMRM.L3;

import java.awt.Color;

import GenCol.entity;
import linkMRM.flitSuper;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class ErrorCheckingModule extends ViewableAtomic{

	protected double delay;
	protected int erroneousWire;
	
	public ErrorCheckingModule() {this("Error Checking Module", .1);}
	public ErrorCheckingModule(String name, double delay){
		super(name);

		addInport("channelOutput");
		addOutport("confirmation");

		this.delay = delay;
		
		this.backgroundColor = Color.LIGHT_GRAY;
	}
	
	public void deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "channelOutput", i)){
				flitSuper travellingFlit = (flitSuper) (x.getValOnPort("channelOutput", i));
				if(travellingFlit.getChecksum())
					holdIn("approve", delay);
				else{ 
					holdIn("reject", delay);
					this.erroneousWire = travellingFlit.getErroneousWire();
				}
			}
		}
	}
	
	public void deltint(){
		passivate();
	}
	
	public message out(){
		message msg = new message();
		if(phaseIs("approve")){
			msg.add(makeContent("confirmation", new entity("ack")));
			System.out.println("Error checking done and acknowledged");
		}
		else{
			msg.add(makeContent("confirmation", new entity(Integer.toString(this.erroneousWire))));
			System.out.println("Error checking done and erroneous wire found : " + this.erroneousWire);
		}
		return msg;
	}
}
