package linkMRM.L3;

import java.awt.Color;
import java.util.Arrays;
import java.util.Random;

import linkMRM.flitSuper;
import model.modeling.message;
import view.modeling.ViewableAtomic;

public class Generator extends ViewableAtomic{

	int experimentsSoFar;
	int allExperiments;
	boolean windowOpen;
	Random rand = new Random();
	
	public Generator(){
		this("Generator");
	}
	
	public Generator(String name){
		super(name);
		
		addInport("ackFromLink");
		addOutport("toLink");
		
		this.backgroundColor = Color.CYAN;

	}
	
	/*initialization*/
	public void initialize( ){
		phase = "active";
		sigma = 1;
		experimentsSoFar = 0;
		allExperiments = 7;
		windowOpen = true;
		super.initialize();
	}
	
	/*External Transition Function*/
	public void  deltext(double e, message x){
		Continue(e);
		for(int i = 0 ; i < x.size() ; i++){
			if(messageOnPort(x, "ackFromLink", i)){
				windowOpen = true;
			}
		}
	}
	
	public void deltint(){
		if(experimentsSoFar >= allExperiments)
			passivate();
		else{
			if(experimentsSoFar == 0 && windowOpen){
				experimentsSoFar++;
				windowOpen = false;
				holdIn("active", 1);
			}
			
			else if(experimentsSoFar == 1 && windowOpen){
				experimentsSoFar++;
				windowOpen = false;
				holdIn("active", 3);
			}
			
			else if(experimentsSoFar == 2 && windowOpen){
				experimentsSoFar++;
				windowOpen = false;
				holdIn("active", 3);
			}
			
			else if(experimentsSoFar == 3 && windowOpen){
				experimentsSoFar++;
				windowOpen = false;
				holdIn("active", 3);
			}
			
			else if(experimentsSoFar == 4 && windowOpen){
				experimentsSoFar++;
				windowOpen = false;
				holdIn("active", 3);
			}
			
			else if(experimentsSoFar == 5 && windowOpen){
				experimentsSoFar++;
				windowOpen = false;
				holdIn("active", 3);
			}
			
			else if(experimentsSoFar == 6 && windowOpen){
				experimentsSoFar++;
				windowOpen = false;
				holdIn("active", 3);
			}

		}
	}
	
	public message out(){
		message m = new message();
		flitSuper thisFlit = null;
		
		if(experimentsSoFar == 0 && windowOpen){
			int[] databits = createRandomeData(Config.databits);
			int[] controlbits = createRandomeData(Config.controlbits);
			thisFlit = new flitSuper(databits, controlbits, flitSuper.FlitType.L3);
		}
		
		else if(experimentsSoFar == 1){
			int[] databits = createRandomeData(Config.databits);
			int[] controlbits = createRandomeData(Config.controlbits);
			thisFlit = new flitSuper(databits, controlbits, flitSuper.FlitType.L3);
		}
		
		else if(experimentsSoFar == 2){
			int[] databits = createErrorOnBit(Config.databits, 3);
			int[] controlbits = createRandomeData(Config.controlbits);
			thisFlit = new flitSuper(databits, controlbits, flitSuper.FlitType.L3);
		}
		
		else if(experimentsSoFar == 3){
			int[] databits = createRandomeData(Config.databits);
			int[] controlbits = createErrorOnBit(Config.controlbits, 0);
			thisFlit = new flitSuper(databits, controlbits, flitSuper.FlitType.L3);
		}
		
		else if(experimentsSoFar == 4){
			int[] databits = createRandomeData(Config.databits);
			int[] controlbits = createRandomeData(Config.controlbits);
			thisFlit = new flitSuper(databits, controlbits, flitSuper.FlitType.L3);
		}
		
		else if(experimentsSoFar == 5){
			int[] databits = createErrorOnBit(Config.databits, 3);
			int[] controlbits = createRandomeData(Config.controlbits);
			thisFlit = new flitSuper(databits, controlbits, flitSuper.FlitType.L3);
		}
		
		else if(experimentsSoFar == 6){
			int[] databits = createRandomeData(Config.databits);
			int[] controlbits = createRandomeData(Config.controlbits);
			thisFlit = new flitSuper(databits, controlbits, flitSuper.FlitType.L3);
		}
		
		else if(experimentsSoFar == 7){
			int[] databits = createRandomeData(Config.databits);
			int[] controlbits = createErrorOnBit(Config.controlbits, 0);
			thisFlit = new flitSuper(databits, controlbits, flitSuper.FlitType.L3);
		}
		
		if(thisFlit != null)
			System.out.println("Gen: generated flit: " + 
				Arrays.toString(thisFlit.getData()) + " - " + Arrays.toString(thisFlit.getControl()));
		
		m.add(makeContent("toLink", thisFlit));
		return m;
	}
	
	public int[] createRandomeData(int numberOfBits){
		int[] data = new int[numberOfBits];
		for(int i = 0 ; i < numberOfBits ; i++)
			data[i] = rand.nextInt(2);
		return data;
	}
	
	public int[] createErrorOnBit(int numberOfBits, int errorBit){
		int[] data = createRandomeData(numberOfBits);
		data[errorBit] = -1; 
		return data;
	}
}