package linkMRM.L3;

import java.awt.Dimension;
import java.awt.Point;

import view.modeling.ViewableComponent;
import view.modeling.ViewableDigraph;

public class Link3 extends ViewableDigraph{

	public Link3(){
		this("Hardware-Level Link");
	}
	
	public Link3(String name) {
		super(name);
		
		addInport("linkIn");
		addOutport("linkOut");
		addOutport("ack");
		addOutport("failStop");
		
		buildModel();
		initialize();
	}

	private void buildModel() {
		Channel channel = new Channel();
		ErrorCheckingModule checksumModule = new ErrorCheckingModule();
		OutputModule outModule = new OutputModule();
		RetransmissionModule retransModule = new RetransmissionModule();
		FailStopModule failStopModule = new FailStopModule();
		ChannelReconfigure reconfigurationModuleUp = new ChannelReconfigure();

		
		add(channel);
		add(checksumModule);
		add(outModule);
		add(retransModule);
		add(failStopModule);
		add(reconfigurationModuleUp);

		addCoupling(this, "linkIn", channel, "channelIn");
		addCoupling(outModule, "linkOut", this, "linkOut");
		addCoupling(outModule, "ack", this, "ack");
		addCoupling(failStopModule, "stop", this, "failStop");

		addCoupling(channel, "channelOut", checksumModule, "channelOutput");
		addCoupling(channel, "channelOut", outModule, "channelOutput");
		
		addCoupling(reconfigurationModuleUp, "reconfig", channel, "upChannelReconfig");
		
		addCoupling(checksumModule, "confirmation", outModule, "confirmation");
		addCoupling(checksumModule, "confirmation", retransModule, "confirmation");
		addCoupling(checksumModule, "confirmation", failStopModule, "confirmation");
		addCoupling(checksumModule, "confirmation", reconfigurationModuleUp, "bitError");

		
		addCoupling(retransModule, "send", channel, "send");
		addCoupling(failStopModule, "stop", channel, "failStopSignal");
	}
	
    /**
     * Automatically generated by the SimView program.
     * Do not edit this manually, as such changes will get overwritten.
     */
    public void layoutForSimView()
    {
        preferredSize = new Dimension(1115, 462);
        ((ViewableComponent)withName("Fail Safe Module")).setPreferredLocation(new Point(279, 343));
        ((ViewableComponent)withName("Channel Reconfig Module")).setPreferredLocation(new Point(10, 158));
        ((ViewableComponent)withName("L3 level Channel")).setPreferredLocation(new Point(262, 248));
        ((ViewableComponent)withName("Error Checking Module")).setPreferredLocation(new Point(422, 132));
        ((ViewableComponent)withName("Output Module")).setPreferredLocation(new Point(657, 185));
        ((ViewableComponent)withName("Retransmission Module")).setPreferredLocation(new Point(135, 20));
    }
}
