package linkMRM;

import java.io.Serializable;

import GenCol.entity;
import linkMRM.L3.Config;

public class flitSuper extends entity implements Serializable{

	public enum FlitType {L2, L3} 
	
	private static final long serialVersionUID = 1L;
	protected FlitType type;
	protected int[] dataBits;
	protected int[] controlBits;

	protected int wrongCount = 0;
	protected int transmissionErrorCount = 0; 

	public flitSuper(int[] dataBits, int[] controlBits, FlitType type){
		this.dataBits = dataBits;
		this.controlBits = controlBits;
		this.type = type;
	}

	public int[] getData(){
		return this.dataBits;
	}

	public int[] getControl(){
		return this.controlBits;
	}

	public boolean getChecksum(){
		if(this.type == FlitType.L2){
			if(wrongCount == transmissionErrorCount)
				return true;
			else{
				this.wrongCount++;
				return false;
			}
		}
		else if(this.type == FlitType.L3){
			for(int i = 0 ; i < this.dataBits.length ; i++)
				if(this.dataBits[i] == -1)
					return false;
			for(int i = 0 ; i < this.controlBits.length ; i++)
				if(this.controlBits[i] == -1)
					return false;

			return true;
		}
		return true;
	}

	public int getErroneousWire(){
		if(this.type == FlitType.L2){
			return -1;
		}
		else if(this.type == FlitType.L3){
			for(int i = 0 ; i < this.dataBits.length ; i++)
				if(this.dataBits[i] == -1){
					this.dataBits[i] = 1;
					return i;
				}
			for(int i = 0 ; i < this.controlBits.length ; i++)
				if(this.controlBits[i] == -1){
					this.controlBits[i] = 1;
					return (i + Config.extraWires + Config.databits);
				}
		}
		return -1;
	}

	public boolean equals(Object other){
		if(!(other instanceof flitSuper))
			return false;
		
		flitSuper otherFlit = (flitSuper)other;
		
		if(this.dataBits.length != otherFlit.dataBits.length)
			return false; 
		
		for(int i = 0 ; i < this.dataBits.length ; i++)
			if(this.dataBits[i] != otherFlit.dataBits[i])
				return false; 
		
		return true;
	}
	
	public void setWrongTransmissionCount(int count) {
		this.transmissionErrorCount = count;
	}
}
